summaryrefslogtreecommitdiffstats
path: root/academic
diff options
context:
space:
mode:
author Lorenzo Trevisan2017-09-23 17:12:38 +0200
committer David Spencer2017-09-23 17:12:38 +0200
commit2b3ebf402315496abda7d4fddcd659cad301ca8e (patch)
treedf63ab9fc04bece63d2a19398a6ac011cd570880 /academic
parent1d1d7530a824742c368a4770dd14d93e7433e6ad (diff)
downloadslackbuilds-2b3ebf402315496abda7d4fddcd659cad301ca8e.tar.gz
academic/dakota: Added (optimization toolkit).
Signed-off-by: David Spencer <idlemoor@slackbuilds.org>
Diffstat (limited to 'academic')
-rw-r--r--academic/dakota/README12
-rw-r--r--academic/dakota/dakota.SlackBuild97
-rw-r--r--academic/dakota/dakota.csh6
-rw-r--r--academic/dakota/dakota.info10
-rw-r--r--academic/dakota/dakota.sh6
-rw-r--r--academic/dakota/doinst.sh26
-rw-r--r--academic/dakota/slack-desc19
7 files changed, 176 insertions, 0 deletions
diff --git a/academic/dakota/README b/academic/dakota/README
new file mode 100644
index 0000000000..01d05fcdec
--- /dev/null
+++ b/academic/dakota/README
@@ -0,0 +1,12 @@
+The Dakota toolkit provides a flexible, extensible interface between
+analysis codes and iteration methods. Dakota contains algorithms for
+optimization with gradient and nongradient-based methods; uncertainty
+quantification with sampling, reliability, stochastic expansion, and
+epistemic methods; parameter estimation with nonlinear least squares
+methods; and sensitivity/variance analysis with design of experiments
+and parameter study capabilities. These capabilities may be used on
+their own or as components within advanced strategies such as
+surrogate-based optimization, mixed integer nonlinear programming, or
+optimization under uncertainty.
+
+Optional dependency: openmpi
diff --git a/academic/dakota/dakota.SlackBuild b/academic/dakota/dakota.SlackBuild
new file mode 100644
index 0000000000..72c600607a
--- /dev/null
+++ b/academic/dakota/dakota.SlackBuild
@@ -0,0 +1,97 @@
+#!/bin/sh
+
+# Slackware build script for Dakota
+
+# Copyright 2017 Lorenzo Trevisan, Caorle, Venice, Italy
+# All rights reserved.
+#
+# Redistribution and use of this script, with or without modification, is
+# permitted provided that the following conditions are met:
+#
+# 1. Redistributions of this script must retain the above copyright
+# notice, this list of conditions and the following disclaimer.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR "AS IS" AND ANY EXPRESS OR IMPLIED
+# WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
+# MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
+# EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
+# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
+# PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
+# OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
+# WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
+# OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
+# ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+
+PRGNAM=dakota
+VERSION=${VERSION:-6.6}
+BUILD=${BUILD:-1}
+TAG=${TAG:-_SBo}
+
+if [ -z "$ARCH" ]; then
+ case "$( uname -m )" in
+ i?86) ARCH=i586 ;;
+ arm*) ARCH=arm ;;
+ *) ARCH=$( uname -m ) ;;
+ esac
+fi
+
+CWD=$(pwd)
+TMP=${TMP:-/tmp/SBo}
+PKG=$TMP/package-$PRGNAM
+OUTPUT=${OUTPUT:-/tmp}
+
+if [ "$ARCH" = "i586" ]; then
+ SLKCFLAGS="-O2 -march=i586 -mtune=i686"
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "i686" ]; then
+ SLKCFLAGS="-O2 -march=i686 -mtune=i686"
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "x86_64" ]; then
+ SLKCFLAGS="-O2 -fPIC"
+ LIBDIRSUFFIX="64"
+else
+ SLKCFLAGS="-O2"
+ LIBDIRSUFFIX=""
+fi
+
+set -e
+
+rm -rf $PKG
+mkdir -p $TMP $PKG $OUTPUT
+cd $TMP
+rm -rf $PRGNAM-$VERSION-release-public.src-UI
+tar xvf $CWD/$PRGNAM-$VERSION-public.src-UI.tar.gz
+cd $PRGNAM-$VERSION-release-public.src-UI
+chown -R root:root .
+find -L . \
+ \( -perm 777 -o -perm 775 -o -perm 750 -o -perm 711 -o -perm 555 \
+ -o -perm 511 \) -exec chmod 755 {} \; -o \
+ \( -perm 666 -o -perm 664 -o -perm 640 -o -perm 600 -o -perm 444 \
+ -o -perm 440 -o -perm 400 \) -exec chmod 644 {} \;
+
+mkdir -p build
+cd build
+ cmake \
+ -DCMAKE_C_FLAGS:STRING="$SLKCFLAGS" \
+ -DCMAKE_CXX_FLAGS:STRING="$SLKCFLAGS" \
+ -DCMAKE_INSTALL_PREFIX=/opt/$PRGNAM \
+ -DCMAKE_BUILD_TYPE=Release ..
+ make
+ make install DESTDIR=$PKG
+cd ..
+
+find $PKG -print0 | xargs -0 file | grep -e "executable" -e "shared object" | grep ELF \
+ | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null || true
+
+install -D -m755 $CWD/$PRGNAM.sh $PKG/etc/profile.d/$PRGNAM.sh.new
+install -D -m755 $CWD/$PRGNAM.csh $PKG/etc/profile.d/$PRGNAM.csh.new
+
+mkdir -p $PKG/usr/doc/$PRGNAM-$VERSION
+cp -a COPYRIGHT LICENSE INSTALL README $PKG/usr/doc/$PRGNAM-$VERSION
+cat $CWD/$PRGNAM.SlackBuild > $PKG/usr/doc/$PRGNAM-$VERSION/$PRGNAM.SlackBuild
+
+mkdir -p $PKG/install
+cat $CWD/slack-desc > $PKG/install/slack-desc
+
+cd $PKG
+/sbin/makepkg -l y -c n $OUTPUT/$PRGNAM-$VERSION-$ARCH-$BUILD$TAG.${PKGTYPE:-tgz}
diff --git a/academic/dakota/dakota.csh b/academic/dakota/dakota.csh
new file mode 100644
index 0000000000..4cd591feae
--- /dev/null
+++ b/academic/dakota/dakota.csh
@@ -0,0 +1,6 @@
+set path=( $path /opt/dakota/bin:/opt/dakota/test )
+if ( $?LD_LIBRARY_PATH ) then
+ setenv LD_LIBRARY_PATH "$LD_LIBRARY_PATH:/opt/dakota/lib:/opt/dakota/bin"
+else
+ setenv LD_LIBRARY_PATH "/opt/dakota/lib:/opt/dakota/bin"
+endif
diff --git a/academic/dakota/dakota.info b/academic/dakota/dakota.info
new file mode 100644
index 0000000000..8e4d22d1bf
--- /dev/null
+++ b/academic/dakota/dakota.info
@@ -0,0 +1,10 @@
+PRGNAM="dakota"
+VERSION="6.6"
+HOMEPAGE="http://dakota.sandia.gov/"
+DOWNLOAD="http://dakota.sandia.gov/sites/default/files/distributions/public/dakota-6.6-public.src-UI.tar.gz"
+MD5SUM="a048041bdc5bcc5a76c1cc1b912cfd02"
+DOWNLOAD_x86_64=""
+MD5SUM_x86_64=""
+REQUIRES="blas lapack"
+MAINTAINER="Lorenzo Trevisan"
+EMAIL="lorenzo.trevisan@gmail.com"
diff --git a/academic/dakota/dakota.sh b/academic/dakota/dakota.sh
new file mode 100644
index 0000000000..4db0d6eae1
--- /dev/null
+++ b/academic/dakota/dakota.sh
@@ -0,0 +1,6 @@
+export PATH=$PATH:/opt/dakota/bin:/opt/dakota/test
+if [ -z "$LD_LIBRARY_PATH" ]; then
+ export LD_LIBRARY_PATH="/opt/dakota/lib:/opt/dakota/bin"
+else
+ export LD_LIBRARY_PATH="$LD_LIBRARY_PATH:/opt/dakota/lib:/opt/dakota/bin"
+fi
diff --git a/academic/dakota/doinst.sh b/academic/dakota/doinst.sh
new file mode 100644
index 0000000000..30268b5327
--- /dev/null
+++ b/academic/dakota/doinst.sh
@@ -0,0 +1,26 @@
+config() {
+ NEW="$1"
+ OLD="$(dirname $NEW)/$(basename $NEW .new)"
+ # If there's no config file by that name, mv it over:
+ if [ ! -r $OLD ]; then
+ mv $NEW $OLD
+ elif [ "$(cat $OLD | md5sum)" = "$(cat $NEW | md5sum)" ]; then
+ # toss the redundant copy
+ rm $NEW
+ fi
+ # Otherwise, we leave the .new copy for the admin to consider...
+}
+
+preserve_perms() {
+ NEW="$1"
+ OLD="$(dirname $NEW)/$(basename $NEW .new)"
+ if [ -e $OLD ]; then
+ cp -a $OLD ${NEW}.incoming
+ cat $NEW > ${NEW}.incoming
+ mv ${NEW}.incoming $NEW
+ fi
+ config $NEW
+}
+
+preserve_perms etc/profile.d/dakota.sh.new
+preserve_perms etc/profile.d/dakota.csh.new
diff --git a/academic/dakota/slack-desc b/academic/dakota/slack-desc
new file mode 100644
index 0000000000..abe39ffa3f
--- /dev/null
+++ b/academic/dakota/slack-desc
@@ -0,0 +1,19 @@
+# HOW TO EDIT THIS FILE:
+# The "handy ruler" below makes it easier to edit a package description.
+# Line up the first '|' above the ':' following the base package name, and
+# the '|' on the right side marks the last column you can put a character in.
+# You must make exactly 11 lines for the formatting to be correct. It's also
+# customary to leave one space after the ':' except on otherwise blank lines.
+
+ |-----handy-ruler------------------------------------------------------|
+dakota: dakota (optimization toolkit)
+dakota:
+dakota: Dakota contains algorithms for optimization with gradient and
+dakota: nongradient-based methods; uncertainty quantification with sampling,
+dakota: reliability, stochastic expansion, and epistemic methods; parameter
+dakota: estimation with nonlinear least squares methods; and sensitivity and
+dakota: variance analysis with design of experiments and parameter study
+dakota: capabilities.
+dakota:
+dakota:
+dakota: